"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = exports.defaultProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pre = _interopRequireDefault(require("@bootstrap-styled/v4/lib/Pre"));

var _lodash = _interopRequireDefault(require("lodash.omit"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lib = _interopRequireDefault(require("map-to-css-modules/lib"));

var _classnames = _interopRequireDefault(require("classnames"));

var defaultProps = {
  theme: {
    styleguide: {
      '$rsg-markdown-pre-font-family': '-apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif;',
      '$rsg-markdown-pre-font-size': '13px',
      '$rsg-markdown-pre-line-height': '1.5',
      '$rsg-markdown-pre-color': '#333',
      '$rsg-markdown-pre-white-space': 'pre',
      '$rsg-markdown-pre-background-color': '#f5f5f5',
      '$rsg-markdown-pre-padding': '8px 16px',
      '$rsg-markdown-pre-border': '1px #e8e8e8 solid',
      '$rsg-markdown-pre-border-radius': '3px',
      '$rsg-markdown-pre-margin': '0 0 16px 0',
      '$rsg-editor-transition': 'all ease-in-out .1s',
      '$rsg-editor-code-comment-color': '#6d6d6d',
      '$rsg-editor-code-punctuation-color': '#999',
      '$rsg-editor-code-namespace-opacity': '0.7',
      '$rsg-editor-code-property-color': '#905',
      '$rsg-editor-code-deleted-color': '#905',
      '$rsg-editor-code-string-color': '#690',
      '$rsg-editor-code-inserted-color': '#690',
      '$rsg-editor-code-operator-color': '#9a6e3a',
      '$rsg-editor-code-keyword-color': '#1673b1',
      '$rsg-editor-code-function-color': '#DD4A68',
      '$rsg-editor-code-variable-color': '#e90',
      '$rsg-editor-code-font-weight': 'bold',
      '$rsg-editor-code-font-style': 'italic',
      '$rsg-editor-code-cursor': 'help'
    }
  }
};
/* eslint-disable react/require-default-props */

exports.defaultProps = defaultProps;
var propTypes = {
  /**
   * @ignore
   */
  className: _propTypes.default.string,
  // eslint-disable-line react/require-default-props
  children: _propTypes.default.node.isRequired,

  /** Theme variables. Can be: */
  theme: _propTypes.default.shape({
    styleguide: _propTypes.default.shape({
      '$rsg-markdown-pre-font-family': _propTypes.default.string,
      '$rsg-markdown-pre-font-size': _propTypes.default.string,
      '$rsg-markdown-pre-line-height': _propTypes.default.string,
      '$rsg-markdown-pre-color': _propTypes.default.string,
      '$rsg-markdown-pre-white-space': _propTypes.default.string,
      '$rsg-markdown-pre-background-color': _propTypes.default.string,
      '$rsg-markdown-pre-padding': _propTypes.default.string,
      '$rsg-markdown-pre-border': _propTypes.default.string,
      '$rsg-markdown-pre-border-radius': _propTypes.default.string,
      '$rsg-markdown-pre-margin': _propTypes.default.string,
      '$rsg-editor-isolate': _propTypes.default.bool,
      '$rsg-editor-code-comment-color': _propTypes.default.string,
      '$rsg-editor-code-punctuation-color': _propTypes.default.string,
      '$rsg-editor-code-namespace-opacity': _propTypes.default.string,
      '$rsg-editor-code-property-color': _propTypes.default.string,
      '$rsg-editor-code-deleted-color': _propTypes.default.string,
      '$rsg-editor-code-string-color': _propTypes.default.string,
      '$rsg-editor-code-inserted-color': _propTypes.default.string,
      '$rsg-editor-code-operator-color': _propTypes.default.string,
      '$rsg-editor-code-keyword-color': _propTypes.default.string,
      '$rsg-editor-code-function-color': _propTypes.default.string,
      '$rsg-editor-code-variable-color': _propTypes.default.string,
      '$rsg-editor-code-font-weight': _propTypes.default.string,
      '$rsg-editor-code-font-style': _propTypes.default.string,
      '$rsg-editor-code-cursor': _propTypes.default.string
    })
  }),

  /**
   * Replace or remove a className from the component.
   * See example <a href="https://www.npmjs.com/package/map-to-css-modules" target="_blank">here</a>.
   */
  cssModule: _propTypes.default.object // eslint-disable-line react/require-default-props

};
/* eslint-enable react/require-default-props */

exports.propTypes = propTypes;

var PreRendererUnstyled = function PreRendererUnstyled(props) {
  var _omit = (0, _lodash.default)(props, ['theme']),
      className = _omit.className,
      children = _omit.children,
      cssModule = _omit.cssModule,
      attributes = (0, _objectWithoutProperties2.default)(_omit, ["className", "children", "cssModule"]);

  return _react.default.createElement(_Pre.default, (0, _extends2.default)({
    className: (0, _lib.default)((0, _classnames.default)(className, 'rsg-markdown-pre'), cssModule)
  }, attributes), children);
};

PreRendererUnstyled.defaultProps = defaultProps;
PreRendererUnstyled.propTypes = propTypes;
var PreRenderer = (0, _styledComponents.default)(PreRendererUnstyled).withConfig({
  displayName: "PreRenderer",
  componentId: "sc-1jda7gz-0"
})(["  ", ""], function (props) {
  return "\n    &.rsg-markdown-pre {\n      font-family: ".concat(props.theme.styleguide['$rsg-markdown-pre-font-family'], ";\n      font-size: ").concat(props.theme.styleguide['$rsg-markdown-pre-font-size'], ";\n      line-height: ").concat(props.theme.styleguide['$rsg-markdown-pre-line-height'], ";\n      color: ").concat(props.theme.styleguide['$rsg-markdown-pre-color'], " !important;\n      white-space: ").concat(props.theme.styleguide['$rsg-markdown-pre-white-space'], ";\n      background-color: ").concat(props.theme.styleguide['$rsg-markdown-pre-background-color'], ";\n      padding: ").concat(props.theme.styleguide['$rsg-markdown-pre-padding'], ";\n      border: ").concat(props.theme.styleguide['$rsg-markdown-pre-border'], ";\n      border-radius: ").concat(props.theme.styleguide['$rsg-markdown-pre-border-radius'], ";\n      margin: ").concat(props.theme.styleguide['$rsg-markdown-pre-margin'], ";\n    }\n    & .token.comment,\n        & .token.doctype,\n          & .token.cdata {\n            isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n            color: ").concat(props.theme.styleguide['$rsg-editor-code-comment-color'], ";\n      }\n      & .token.punctuation {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        color: ").concat(props.theme.styleguide['$rsg-editor-code-punctuation-color'], ";\n      }\n      & .namespace {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        opacity: ").concat(props.theme.styleguide['$rsg-editor-code-namespace-opacity'], ";\n      }\n      & .token.property,\n        & .token.tag,\n          & .token.boolean,\n            & .token.number,\n              & .token.constant,\n                & .token.symbol {\n                  isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n                  color: ").concat(props.theme.styleguide['$rsg-editor-code-property-color'], ";\n      }\n      & .token.deleted {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        color: ").concat(props.theme.styleguide['$rsg-editor-code-deleted-color'], ";\n      }\n      & .token.selector,\n        & .token.attr-name,\n          & .token.string,\n            & .token.char,\n              & .token.builtin {\n                isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n                color: ").concat(props.theme.styleguide['$rsg-editor-code-string-color'], ";\n      }\n      & .token.inserted {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        color: ").concat(props.theme.styleguide['$rsg-editor-code-inserted-color'], ";\n      }\n      & .token.operator,\n        & .token.entity,\n          & .token.url,\n            & .language-css .token.string,\n              & .style .token.string {\n                isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n                color: ").concat(props.theme.styleguide['$rsg-editor-code-operator-color'], ";\n      }\n      & .token.atrule,\n        & .token.attr-value,\n          & .token.keyword {\n            isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n            color: ").concat(props.theme.styleguide['$rsg-editor-code-keyword-color'], ";\n      }\n      & .token.function,\n        & .token.class-name{\n          isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n          color: ").concat(props.theme.styleguide['$rsg-editor-code-function-color'], ";\n      }\n      & .token.regex,\n        & .token.important,\n          & .token.variable {\n            isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n            color: ").concat(props.theme.styleguide['$rsg-editor-code-variable-color'], ";\n      }\n      & .token.important,\n        & .token.bold{\n          isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n          font-weight: ").concat(props.theme.styleguide['$rsg-editor-code-font-weight'], ";\n      }\n      & .token.italic {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        font-style: ").concat(props.theme.styleguide['$rsg-editor-code-font-style'], ";\n      }\n      & .token.entity {\n        isolate: ").concat(props.theme.styleguide['$rsg-editor-isolate'], ";\n        cursor: ").concat(props.theme.styleguide['$rsg-editor-code-cursor'], ";\n      }\n ");
});
PreRenderer.defaultProps = defaultProps;
PreRenderer.propTypes = propTypes;
var _default = PreRenderer;
exports.default = _default;